## ipp-crypto 1.0.0

=== CMakeLists.txt ===
#=========================================================================
# Copyright (C) 2017 Intel Corporation
#
# Licensed under the Apache License,  Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# 	http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law  or agreed  to  in  writing,  software
# distributed under  the License  is  distributed  on  an  "AS IS"  BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the  specific  language  governing  permissions  and
# limitations under the License.
#=========================================================================

#
# Intel® Cryptography Primitives Library
#

cmake_minimum_required(VERSION 3.12)

include("${CMAKE_CURRENT_SOURCE_DIR}/sources/cmake/ippcp-utils.cmake")
ippcp_getlibversion("${CMAKE_CURRENT_SOURCE_DIR}/include/ippcpversion.h")
if ((NOT DEFINED IPPCP_VERSION_MAJOR) OR
    (NOT DEFINED IPPCP_VERSION_MINOR) OR
    (NOT DEFINED IPPCP_VERSION_UPDATE) OR
    (NOT DEFINED IPPCP_INTERFACE_VERSION_MAJOR) OR
    (NOT DEFINED IPPCP_INTERFACE_VERSION_MINOR))
    message(WARNING "Cannot parse version from ippcpversion.h file. The project might be corrupted.")
endif()

set(PROJECT_FULL_NAME "Intel® Cryptography Primitives Library")
set(PROJECT_VERSION ${IPPCP_VERSION})

set(LIB_NAME ippcp)

set(CMAKE_CONFIGURATION_TYPES "Debug;Release" CACHE STRING "" FORCE)

cmake_policy(SET CMP0042 NEW)
cmake_policy(SET CMP0054 NEW)
cmake_policy(SET CMP0068 NEW)

if("${CMAKE_GENERATOR}" STREQUAL "NMake Makefiles")
  if(NOT(C_COMPILER  STREQUAL ""))
    set(CMAKE_C_COMPILER ${C_COMPILER})
  endif()
  if(NOT(CXX_COMPILER STREQUAL ""))
    set(CMAKE_CXX_COMPILER ${CXX_COMPILER})
  endif()
endif()

project(${PROJECT_FULL_NAME}
        VERSION ${PROJECT_VERSION}
        LANGUAGES C CXX)

if("${CMAKE_BUILD_TYPE}" STREQUAL "")
  message(STATUS "CMAKE_BUILD_TYPE is unset, defaulting to Release")
  set(CMAKE_BUILD_TYPE "Release")
endif()

find_package(Python REQUIRED)

if(WIN32 AND (${CMAKE_GENERATOR} MATCHES "Visual Studio"))
  if(CMAKE_GENERATOR_PLATFORM) # VS 2019+ -A param
    if(${CMAKE_GENERATOR_PLATFORM} MATCHES "x64")
      set(ARCH intel64)
    else()
      set(ARCH ia32)
    endif()
  else()
    if(${CMAKE_GENERATOR} MATCHES "Win64") # old way of platform setting for VS
      set(ARCH intel64)
    else()
      set(ARCH ia32)
    endif()
  endif()
else()
  if (NOT "${ARCH}" STREQUAL "intel64" AND NOT "${ARCH}" STREQUAL "ia32")
    message(FATAL_ERROR "Please, set the ARCH parameter to ia32 or intel64")
  endif()
endif(WIN32 AND (${CMAKE_GENERATOR} MATCHES "Visual Studio"))

if ((NOT NONPIC_LIB) AND (NOT CODE_COVERAGE))
  set(DYNAMIC_LIB ON)
else()
  set(DYNAMIC_LIB OFF)
endif()

if("${MERGED_BLD}" STREQUAL "")
  set(MERGED_BLD ON)
endif()

# Set default installation directories
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  if (UNIX)
    set(CMAKE_INSTALL_PREFIX "$ENV{HOME}/intel/ippcp_${PROJECT_VERSION}" CACHE PATH "..." FORCE)
  else()
    set(CMAKE_INSTALL_PREFIX "c:/Program Files (x86)/IntelSWTools/ippcp_${PROJECT_VERSION}" CACHE PATH "..." FORCE)
  endif()
endif()

set(IPP_CRYPTO_DIR                  "${CMAKE_CURRENT_SOURCE_DIR}")
set(IPP_CRYPTO_INCLUDE_DIR          "${IPP_CRYPTO_DIR}/include")
set(IPP_CRYPTO_SOURCES_INCLUDE_DIR  "${IPP_CRYPTO_DIR}/sources/include")
set(IPP_CRYPTO_SOURCES_DIR          "${IPP_CRYPTO_DIR}/sources/ippcp")
set(IPP_CRYPTO_DISPATCHER_DIR       "${IPP_CRYPTO_DIR}/sources/dispatcher")
set(TOOLS_DIR                       "${IPP_CRYPTO_DIR}/tools")

if(NOT CMAKE_OUTPUT_DIR)
  set(CMAKE_OUTPUT_DIR              "${CMAKE_BINARY_DIR}/.build")
endif()

message (STATUS "CMAKE_VERSION ......................... " ${CMAKE_VERSION})

if(UNIX AND NOT APPLE)
  if(NONPIC_LIB)
    message (STATUS "NONPIC_LIB ............................ on")
  else()
    message (STATUS "NONPIC_LIB ............................ off")
  endif()
else()
  set(${NONPIC_LIB} false)
endif(UNIX AND NOT APPLE)

set(NONPIC_SUBDIRECTORY "")
if(NONPIC_LIB)
  set(NONPIC_SUBDIRECTORY "/nonpic")
endif()

foreach( OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES} )
  string( TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG )
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} "${CMAKE_OUTPUT_DIR}/${OUTPUTCONFIG}/lib${NONPIC_SUBDIRECTORY}")
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} "${CMAKE_OUTPUT_DIR}/${OUTPUTCONFIG}/lib${NONPIC_SUBDIRECTORY}")
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} "${CMAKE_OUTPUT_DIR}/${OUTPUTCONFIG}/lib${NONPIC_SUBDIRECTORY}")
endforeach( OUTPUTCONFIG CMAKE_CONFIGURATION_TYPES )

if(${CMAKE_BUILD_TYPE} STREQUAL "Release")
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELEASE}")
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELEASE}")
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELEASE}")
endif()

if(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_LIBRARY_OUTPUT_DIRECTORY_DEBUG}")
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_ARCHIVE_OUTPUT_DIRECTORY_DEBUG}")
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_RUNTIME_OUTPUT_DIRECTORY_DEBUG}")
endif()

if (CRYPTO_USE_CLANG_TIDY AND ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang" AND ${CMAKE_CXX_COMPILER_VERSION} VERSION_GREATER_EQUAL "12.0.0")
    find_program(DO_CLANG_TIDY NAMES clang-tidy)
    set(CMAKE_CXX_CLANG_TIDY ${DO_CLANG_TIDY})
    set(CMAKE_C_CLANG_TIDY ${DO_CLANG_TIDY})
endif ()

message (STATUS "PROJECT ............................... " ${PROJECT_FULL_NAME})
message (STATUS "CMAKE_BINARY_DIR ...................... " ${CMAKE_BINARY_DIR})
message (STATUS "CMAKE_OUTPUT_DIR ...................... " ${CMAKE_OUTPUT_DIR})
message (STATUS "CMAKE_SOURCE_DIR ...................... " ${CMAKE_SOURCE_DIR})
message (STATUS "IPP_CRYPTO_DIR ........................ " ${IPP_CRYPTO_DIR})
message (STATUS "CMAKE_GENERATOR ....................... " ${CMAKE_GENERATOR})
message (STATUS "CMAKE_C_COMPILER_ID ................... " ${CMAKE_C_COMPILER_ID})
message (STATUS "CMAKE_CXX_COMPILER_ID ................. " ${CMAKE_CXX_COMPILER_ID})
message (STATUS "IPP_CRYPTO_INCLUDE_DIR ................ " ${IPP_CRYPTO_INCLUDE_DIR})
message (STATUS "IPP_CRYPTO_SOURCES_INCLUDE_DIR ........ " ${IPP_CRYPTO_SOURCES_INCLUDE_DIR})
message (STATUS "IPP_CRYPTO_SOURCES_DIR ................ " ${IPP_CRYPTO_SOURCES_DIR})
message (STATUS "ARCH .................................. " ${ARCH})
message (STATUS "DYNAMIC_LIB ........................... " ${DYNAMIC_LIB})
message (STATUS "CMAKE_INSTALL_PREFIX .................. " ${CMAKE_INSTALL_PREFIX})

if(CRYPTO_USE_CLANG_TIDY)
  message (STATUS "CLANG_TIDY ............................ on")
else()
  message (STATUS "CLANG_TIDY ............................ off")
endif()

if(Python_Interpreter_FOUND)
  message (STATUS "PYTHON_VERSION_STRING ................. " ${Python_VERSION})
else()
  message (STATUS "PYTHON_VERSION_STRING ................. Python not found" )
endif()

if(MERGED_BLD)
  message (STATUS "MERGED_BLD ............................ on")
else()
  message (STATUS "MERGED_BLD ............................ off")
endif()

option(BUILD_EXAMPLES "Build examples" OFF)
if(BUILD_EXAMPLES)
  message (STATUS "BUILD_EXAMPLES ........................ on")
else()
  message (STATUS "BUILD_EXAMPLES ........................ off")
endif()

# Build with sanitizers
set(SANITIZERS OFF)
if(BUILD_WITH_SANITIZERS AND UNIX AND ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang" AND ${CMAKE_CXX_COMPILER_VERSION} VERSION_GREATER_EQUAL "12.0.0")
  set(ASAN OFF)
  set(UBSAN OFF)
  set(MSAN OFF)
  if("${BUILD_WITH_SANITIZERS}" MATCHES "address")
    set(ASAN ON)
    list(APPEND PRINT_TYPES_OF_SANITIZERS_LIST "address")
  endif()
  if("${BUILD_WITH_SANITIZERS}" MATCHES "undefined")
    set(UBSAN ON)
    list(APPEND PRINT_TYPES_OF_SANITIZERS_LIST "undefined")
  endif()
  if("${BUILD_WITH_SANITIZERS}" MATCHES "memory")
    set(MSAN ON)
    list(APPEND PRINT_TYPES_OF_SANITIZERS_LIST "memory")
  endif()
  if((ASAN OR UBSAN) AND MSAN)
    message (FATAL_ERROR "Can not use address | undefined sanitizers with memory sanitizer")
  endif()
  if(ASAN OR UBSAN OR MSAN)
    set(SANITIZERS ON)
  endif()
endif()
if(SANITIZERS)
  list(JOIN PRINT_TYPES_OF_SANITIZERS_LIST "," PRINT_TYPES_OF_SANITIZERS_STRING)
  message (STATUS "BUILD_WITH_SANITIZERS ................. on (${PRINT_TYPES_OF_SANITIZERS_STRING})")
else()
  message (STATUS "BUILD_WITH_SANITIZERS ................. off - use -DBUILD_WITH_SANITIZERS=[memory,address,undefined] with CLANG compiler to enable this option")
endif(SANITIZERS)

if((UNIX) AND (NOT APPLE))
  set(LINUX ON)
else()
  set(LINUX OFF)
endif()

add_subdirectory(sources/ippcp)

if (NOT (CRYPTO_USE_CLANG_TIDY))

  if(EXISTS "${IPP_CRYPTO_DIR}/tests/")
    add_subdirectory(tests)
  endif()
  if(EXISTS "${IPP_CRYPTO_DIR}/perf_tests/")
    add_subdirectory(perf_tests)
  endif()
endif()


if(BUILD_EXAMPLES)
  # This helps to organize examples projects structure in IDE by folders
  set_property(GLOBAL PROPERTY USE_FOLDERS ON)
  set_property(GLOBAL PROPERTY PREDEFINED_TARGETS_FOLDER "CMakeTargets")

  add_subdirectory(examples)
endif()

=== examples/CMakeLists.txt ===
#=========================================================================
# Copyright (C) 2019 Intel Corporation
#
# Licensed under the Apache License,  Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# 	http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law  or agreed  to  in  writing,  software
# distributed under  the License  is  distributed  on  an  "AS IS"  BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the  specific  language  governing  permissions  and
# limitations under the License.
#=========================================================================

#
# Intel® Cryptography Primitives Library examples
#

# List of examples for targets generation
set(IPPCP_EXAMPLES
  # AES-CTR examples
  aes/aes-256-ctr-encryption.cpp
  aes/aes-256-ctr-decryption.cpp
  # AES-GCM examples
  aes/aes-128-gcm-encryption.cpp
  aes/aes-128-gcm-decryption.cpp
  # DSA
  dsa/dsa-dlp-sha-1-verification.cpp
  dsa/dsa-dlp-sha-256-verification.cpp
  # RSA SSA-PSS examples
  rsa/rsa-3k-pss-sha384-type1-signature.cpp
  rsa/rsa-1k-pss-sha1-verification.cpp
  # RSA OAEP examples
  rsa/rsa-1k-oaep-sha1-encryption.cpp
  rsa/rsa-1k-oaep-sha1-type2-decryption.cpp
  # SMS4 examples
  sms4/sms4-128-cbc-encryption.cpp
  sms4/sms4-128-cbc-decryption.cpp
  # Hash examples
  hash/sm3_hash_rmf.cpp
  # Post-quantum algorithms examples
  post-quantum/lms_m32_h5_w8_verification.cpp
  # Elliptic curve algorithms examples
  ecdsa/ecdsa-256r1-sign.cpp 
  )

cmake_policy(SET CMP0003 NEW)

# Custom target to build ALL examples at once
add_custom_target(ippcp_examples_all)
set_target_properties(ippcp_examples_all PROPERTIES FOLDER "examples")

function(ippcp_define_example out_target source_file category)
  # Extract file name without directory or longest extension
  get_filename_component(name "${source_file}" NAME_WE)
  # Add suffix for nonpic build
  if (NONPIC_LIB)
    set(suffix "-nonpic")
  endif()
  set(local_target "example_${name}${suffix}")
  # link additional sources if defined in categoryOptions.cmake
  set(additional_sources "${category}_CATEGORY_COMMON_SOURCES")
  add_executable(${local_target} "${source_file}"
                                 $<$<BOOL:${${additional_sources}}>:${${additional_sources}}>)
  # Static linking with merged lib is only supported
  set(LIBRARY_NAMES_LIST ${IPPCP_LIB_MERGED})
  ippcp_example_set_build_options(${local_target} "${LIBRARY_NAMES_LIST}")
  set_target_properties(${local_target} PROPERTIES
                        PROJECT_LABEL "(example) ${name}"    # Set name of the target in IDE
                        FOLDER "examples/${category}"        # Group projects in solution folder
                        RUNTIME_OUTPUT_DIRECTORY_RELEASE "${CMAKE_OUTPUT_DIR}/$<UPPER_CASE:$<CONFIG>>/examples"  # Set output directory for examples in the build folder
                        RUNTIME_OUTPUT_DIRECTORY_DEBUG   "${CMAKE_OUTPUT_DIR}/$<UPPER_CASE:$<CONFIG>>/examples"
                        COMPILE_DEFINITIONS _NO_IPP_DEPRECATED) # ignore deprecation warnings

  # Add a single target to build all examples of the same category (e.g. 'make ippcp_examples_aes')
  set(parent_target ippcp_examples_${category})
  if(NOT TARGET ${parent_target})
    add_custom_target(${parent_target})
    set_target_properties(${parent_target} PROPERTIES FOLDER "examples")
    if(TARGET ippcp_examples_all)
      add_dependencies(ippcp_examples_all ${parent_target})
    endif()
  endif()
  add_dependencies(${parent_target} ${local_target})
  set(${out_target} ${local_target} PARENT_SCOPE)
endfunction()

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_LIST_DIR)
# Build with standalone library
  cmake_minimum_required(VERSION 3.1)

  project("Intel Cryptography Primitives Library Examples" CXX)
  set(CMAKE_CONFIGURATION_TYPES "Debug;Release" CACHE STRING "" FORCE)

  option(BUILD_EXAMPLES "Build examples" ON)

  list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR})
  find_package(IPPCrypto REQUIRED MODULE)

  if (NOT IPPCRYPTO_FOUND)
    message(FATAL_ERROR "No Intel Cryptography Primitives Library found on the system. To build examples with pre-built library, please specify -DIPPCRYPTO_ROOT_DIR=<path> option, where <path> is the path to directory that contains include/ and lib/ folders of Intel Cryptography Primitives Library product.")
  endif()

  # Define library to link
  list(GET IPPCRYPTO_LIBRARIES 0 IPPCP_LIB_MERGED)
  # Define include folder
  set(IPP_CRYPTO_INCLUDE_DIR ${IPPCRYPTO_INCLUDE_DIRS})
  # Define output directory
  if(NOT CMAKE_OUTPUT_DIR)
    set(CMAKE_OUTPUT_DIR "${CMAKE_BINARY_DIR}/.build")
  endif()
else()
# Build with library sources
  if(NOT BUILD_EXAMPLES OR NOT MERGED_BLD)
    message(FATAL_ERROR "Only merged library build is currently supported for Intel Cryptography Primitives Library examples. Use -DMERGED_BLD:BOOL=on options.")
  endif()
endif()

include(examplesBuildOptions.cmake)

foreach(example_filename ${IPPCP_EXAMPLES})
  # Extract example category from its subdirectory
  get_filename_component(category "${example_filename}" DIRECTORY)

  # Source additional options that may exist for category
  include(${category}/categoryOptions.cmake OPTIONAL)

  ippcp_define_example(example ${example_filename} ${category})
endforeach()

=== sources/ippcp/CMakeLists.txt ===
#=========================================================================
# Copyright (C) 2017 Intel Corporation
#
# Licensed under the Apache License,  Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# 	http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law  or agreed  to  in  writing,  software
# distributed under  the License  is  distributed  on  an  "AS IS"  BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the  specific  language  governing  permissions  and
# limitations under the License.
#=========================================================================

#
# Intel® Cryptography Primitives Library
#

include (GenerateExportHeader)

set(TARGET_NAME ${LIB_NAME})

#Set platform list
if (NOT MERGED_BLD)
  if(${ARCH} MATCHES "ia32")
    set(BASE_PLATFORM_LIST px)
  else()
    set(BASE_PLATFORM_LIST mx)
  endif()
endif()
if(WIN32)
  if(${ARCH} MATCHES "ia32")
    set(BASE_PLATFORM_LIST_1CPU ${BASE_PLATFORM_LIST} w7 s8 p8 g9 h9)
    set(BASE_PLATFORM_LIST ${BASE_PLATFORM_LIST} w7 p8 h9)
  else()
    set(BASE_PLATFORM_LIST_1CPU ${BASE_PLATFORM_LIST} m7 n8 y8 e9 l9 k0 k1)
    set(BASE_PLATFORM_LIST ${BASE_PLATFORM_LIST} m7 y8 l9 k0 k1)
  endif()
endif(WIN32)
if(UNIX)
  if(APPLE)
    set(BASE_PLATFORM_LIST_1CPU ${BASE_PLATFORM_LIST} y8 e9 l9 k0 k1)
    set(BASE_PLATFORM_LIST ${BASE_PLATFORM_LIST} y8 l9 k0 k1)
  else()
    if (${ARCH} MATCHES "ia32")
      set(BASE_PLATFORM_LIST_1CPU ${BASE_PLATFORM_LIST} w7 s8 p8 g9 h9)
      set(BASE_PLATFORM_LIST ${BASE_PLATFORM_LIST} w7 p8 h9)
    else()
      set(BASE_PLATFORM_LIST_1CPU ${BASE_PLATFORM_LIST} m7 n8 y8 e9 l9 k0 k1)
      set(BASE_PLATFORM_LIST ${BASE_PLATFORM_LIST} m7 y8 l9 k0 k1)
    endif(${ARCH} MATCHES "ia32")
  endif(APPLE)
endif(UNIX)

if(PLATFORM_LIST)
  if (NOT MERGED_BLD)
    foreach(opt ${PLATFORM_LIST})
      set(FOUND_PLATFORM false)
      foreach(base_opt ${BASE_PLATFORM_LIST_1CPU})
        string(STRIP "${opt}" opt_strip)
        if(opt_strip STREQUAL base_opt)
          set(FOUND_PLATFORM true)
        endif()
      endforeach(base_opt ${BASE_PLATFORM_LIST_1CPU})
      if(NOT FOUND_PLATFORM)
        message (FATAL_ERROR "Incorrect platform: " ${opt})
      endif()
    endforeach(opt ${PLATFORM_LIST})
    if (PLATFORM_LIST STREQUAL "")
      message (FATAL_ERROR "PLATFORM_LIST cannot be empty")
    endif(PLATFORM_LIST STREQUAL "")
    message (STATUS "Platform list ......................... " ${PLATFORM_LIST})
  else()
    message (FATAL_ERROR "PLATFORM_LIST cannot be set, when MERGED_BLD is on")
  endif(NOT MERGED_BLD)
endif()

# Platform-specific definitions
set(px_def "_PX")
set(w7_def "_W7")
set(s8_def "_S8")
set(p8_def "_P8")
set(g9_def "_G9")
set(h9_def "_H9")
set(mx_def "_PX")
set(m7_def "_M7")
set(n8_def "_N8")
set(y8_def "_Y8")
set(e9_def "_E9")
set(l9_def "_L9")
set(k0_def "_K0")
set(k1_def "_K1")

if(NOT PLATFORM_LIST)
  set(PLATFORM_LIST ${BASE_PLATFORM_LIST})
endif()

if (NOT MERGED_BLD)
  set(PLATFORM_LIST ${PLATFORM_LIST} PARENT_SCOPE)
endif(NOT MERGED_BLD)

# define defaults for every supported compiler
set(DEFAULT_Intel_COMPILER_VER 19.0.0)
set(DEFAULT_MSVC_COMPILER_VER 19.14)
set(DEFAULT_GNU_COMPILER_VER 8.2.0)
set(DEFAULT_APPLE_CLANG_COMPILER_VER 12.0.0)
set(DEFAULT_Clang_COMPILER_VER 9.0.0)

set(DEFAULT_Intel18_COMPILER_VER 18.0.0)
set(DEFAULT_Intel19_COMPILER_VER 19.0.0)
set(DEFAULT_MSVC19_COMPILER_VER 19.14)
set(DEFAULT_IntelLLVM_COMPILER_VER 2023.1.0)

string(REGEX REPLACE "^([0-9]+)\\.([0-9]+)\\.([0-9]+).*$" "\\1.\\2.\\3" CMAKE_C_COMPILER_VERSION_SHORT ${CMAKE_C_COMPILER_VERSION})
string(REGEX REPLACE "^([0-9]+)\\..*$" "\\1" CMAKE_C_COMPILER_VERSION_MAJOR ${CMAKE_C_COMPILER_VERSION})

if(UNIX)
  if(APPLE)
    set(OS_STRING "macosx")
  else()
    set(OS_STRING "linux")
  endif()
else()
  set(OS_STRING   "windows")
endif()

# common build options and ${OS_DEFAULT_COMPILER}
include("${IPP_CRYPTO_DIR}/sources/cmake/${OS_STRING}/common.cmake")
include("${IPP_CRYPTO_DIR}/sources/cmake/os_common.cmake")

if(("${CMAKE_C_COMPILER_ID}" STREQUAL "MSVC") AND (CMAKE_C_COMPILER_VERSION VERSION_LESS DEFAULT_MSVC_COMPILER_VER))
  message(FATAL_ERROR "Microsoft Visual C++ Compiler version must be 19.14 or higher (MSVC 19.14 or higher)")
endif()

if(("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU") AND (CMAKE_C_COMPILER_VERSION VERSION_LESS DEFAULT_GNU_COMPILER_VER))
  message(FATAL_ERROR "GNU C Compiler version must be 8.2 or higher")
endif()

if(("${CMAKE_C_COMPILER_ID}" STREQUAL "AppleClang") AND (CMAKE_C_COMPILER_VERSION VERSION_LESS DEFAULT_APPLE_CLANG_COMPILER_VER))
  message(FATAL_ERROR "Apple Clang C Compiler version must be 12.0 or higher")
endif()

if(("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang") AND (CMAKE_C_COMPILER_VERSION VERSION_LESS DEFAULT_CLANG_COMPILER_VER))
  message(FATAL_ERROR "Clang C Compiler version must be 9.0 or higher")
endif()

if(("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang") OR ("${CMAKE_C_COMPILER_ID}" STREQUAL "AppleClang"))
  set(CLANG_COMPILER ON)
  set(CLANG_COMPILER ${CLANG_COMPILER} PARENT_SCOPE)
endif()

# Compiler options file
set(COMPILER_OPTIONS_FILE "${IPP_CRYPTO_DIR}/sources/cmake/${OS_STRING}")
if (EXISTS "${COMPILER_OPTIONS_FILE}/${CMAKE_C_COMPILER_ID}${CMAKE_C_COMPILER_VERSION_SHORT}.cmake")
  set(COMPILER_OPTIONS_FILE "${COMPILER_OPTIONS_FILE}/${CMAKE_C_COMPILER_ID}${CMAKE_C_COMPILER_VERSION_SHORT}.cmake")
else()
  if ("${DEFAULT_${CMAKE_C_COMPILER_ID}${CMAKE_C_COMPILER_VERSION_MAJOR}_COMPILER_VER}" STREQUAL "")
    if ("${DEFAULT_${CMAKE_C_COMPILER_ID}_COMPILER_VER}" STREQUAL "")
      set(COMPILER_OPTIONS_FILE "${COMPILER_OPTIONS_FILE}/${OS_DEFAULT_COMPILER}.cmake")
      message(WARNING "Unknown compiler, using options from the OS default one: ${OS_DEFAULT_COMPILER}")
    else()
      set(COMPILER_OPTIONS_FILE "${COMPILER_OPTIONS_FILE}/${CMAKE_C_COMPILER_ID}${DEFAULT_${CMAKE_C_COMPILER_ID}_COMPILER_VER}.cmake")
      if(CMAKE_C_COMPILER_VERSION VERSION_LESS ${DEFAULT_${CMAKE_C_COMPILER_ID}_COMPILER_VER})
        message(WARNING "Version of the compiler is lower than default, using options from: ${DEFAULT_${CMAKE_C_COMPILER_ID}_COMPILER_VER}")
      endif()
    endif()
  else()
    set(COMPILER_OPTIONS_FILE "${COMPILER_OPTIONS_FILE}/${CMAKE_C_COMPILER_ID}${DEFAULT_${CMAKE_C_COMPILER_ID}${CMAKE_C_COMPILER_VERSION_MAJOR}_COMPILER_VER}.cmake")
  endif()
endif()
message (STATUS "Using compiler options from ........... " ${COMPILER_OPTIONS_FILE})

# Assembler options
# Note: do not move this initialization after LIBRARY_DEFINES extension
set(CMAKE_USER_MAKE_RULES_OVERRIDE_ASM "${IPP_CRYPTO_DIR}/sources/cmake/CMakeASM_NASMOptions.txt")
enable_language(ASM_NASM)
if(NOT CMAKE_ASM_NASM_COMPILER_LOADED)
  message(FATAL_ERROR "Can't find assembler")
endif()
message(STATUS "ASM compiler version .................. " ${CMAKE_ASM_NASM_COMPILER})
message(STATUS "ASM object format ..................... " ${CMAKE_ASM_NASM_OBJECT_FORMAT})

# set Intel Cryptography Primitives Library revision, if required
if(IPP_REVISION)
  # IPP_REVISION - release revision id, added into LibraryVersion
  set(LIBRARY_DEFINES "${LIBRARY_DEFINES} -DIPP_REVISION=${IPP_REVISION}")
endif()

# Enable tech-preview feature in the library
set(LIBRARY_DEFINES "${LIBRARY_DEFINES} -DIPPCP_PREVIEW_XMSS -DIPPCP_PREVIEW_LMS")

set(LIBRARY_DEFINES "${LIBRARY_DEFINES} -D_NO_IPP_DEPRECATED") # do not warn about ippcp deprecated functions
# set BN_OPENSSL_DISABLE for Intel Cryptography Primitives Library
# set(LIBRARY_DEFINES "${LIBRARY_DEFINES} -DBN_OPENSSL_DISABLE")

if(IPPCP_FIPS_MODE)
  set(LIBRARY_DEFINES "${LIBRARY_DEFINES} -DIPPCP_FIPS_MODE")
  # Internal memory management in FIPS Selftests
  if(IPPCP_SELFTEST_USE_MALLOC)
    set(LIBRARY_DEFINES "${LIBRARY_DEFINES} -DIPPCP_SELFTEST_USE_MALLOC")
  endif()
endif()

include(${COMPILER_OPTIONS_FILE}) # uses ${CMAKE_C_FLAGS} ${LIBRARY_DEFINES} ${<letter>opt} from the scope
if(UNIX)
  set(CMAKE_C_CREATE_SHARED_LIBRARY "<CMAKE_C_COMPILER> <CMAKE_SHARED_LIBRARY_C_FLAGS> <LANGUAGE_COMPILE_FLAGS> <LINK_FLAGS> ${LIB_EXPORT_FILE} <CMAKE_SHARED_LIBRARY_CREATE_C_FLAGS> <SONAME_FLAG><TARGET_SONAME> -o <TARGET> <OBJECTS> <LINK_LIBRARIES>")
  set(CMAKE_CXX_CREATE_SHARED_LIBRARY "<CMAKE_CXX_COMPILER> <CMAKE_SHARED_LIBRARY_CXX_FLAGS> <LANGUAGE_COMPILE_FLAGS> <LINK_FLAGS> ${LIB_EXPORT_FILE} <CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS> <SONAME_FLAG><TARGET_SONAME> -o <TARGET> <OBJECTS> <LINK_LIBRARIES>")
  if("${CMAKE_C_COMPILER_ID}" STREQUAL "AppleClang")
    string(REPLACE "<SONAME_FLAG><TARGET_SONAME>" "<SONAME_FLAG> <TARGET_SONAME>" CMAKE_C_CREATE_SHARED_LIBRARY ${CMAKE_C_CREATE_SHARED_LIBRARY})
    string(REPLACE "<SONAME_FLAG><TARGET_SONAME>" "<SONAME_FLAG> <TARGET_SONAME>" CMAKE_CXX_CREATE_SHARED_LIBRARY ${CMAKE_CXX_CREATE_SHARED_LIBRARY})
  endif()
endif(UNIX)

if(NOT MERGED_BLD)
  set(IPPCP_LIB_STATIC "")
  set(IPPCP_LIB_DYNAMIC "")
endif(NOT MERGED_BLD)

file(GLOB IPPCP_PUBLIC_HEADERS
    ${IPP_CRYPTO_INCLUDE_DIR}/*.h)


file(GLOB LIBRARY_HEADERS
    ${IPP_CRYPTO_SOURCES_DIR}/*.h
    ${IPP_CRYPTO_SOURCES_INCLUDE_DIR}/*.h
    ${IPP_CRYPTO_INCLUDE_DIR}/ippcp*.h
    # RSA_SB (ifma) uses crypto_mb headers
    ${IPP_CRYPTO_SOURCES_DIR}/crypto_mb/include/crypto_mb/*.h
   )

file(GLOB LIBRARY_C_SOURCES_ORIGINAL
    ${IPP_CRYPTO_SOURCES_DIR}/*.c
    ${IPP_CRYPTO_SOURCES_DIR}/hash/*.c
    ${IPP_CRYPTO_SOURCES_DIR}/hash/*/*.c
    ${IPP_CRYPTO_SOURCES_DIR}/gfpec/*.c
    ${IPP_CRYPTO_SOURCES_DIR}/gfpec/*/*.c
    ${IPP_CRYPTO_SOURCES_DIR}/xmss/*.c
    ${IPP_CRYPTO_SOURCES_DIR}/lms/*.c
)

file(GLOB LIBRARY_ASM_SOURCES_ORIGINAL
        ${IPP_CRYPTO_SOURCES_DIR}/asm_${ARCH}/*.asm
    )

set(INTERNAL_INCLUDE_DIR ${CMAKE_BINARY_DIR}/include/autogen_1cpu)

set (C_INCLUDE_DIRECTORIES
    ${IPP_CRYPTO_SOURCES_DIR}
    ${IPP_CRYPTO_SOURCES_INCLUDE_DIR}
    ${IPP_CRYPTO_INCLUDE_DIR}
    ${INTERNAL_INCLUDE_DIR}
    # RSA_SB (ifma) uses crypto_mb headers
    ${IPP_CRYPTO_SOURCES_DIR}/crypto_mb/include
    $<$<C_COMPILER_ID:Intel>:$ENV{ROOT}/compiler/include $ENV{ROOT}/compiler/include/icc>
    $<$<NOT:$<C_COMPILER_ID:Intel>>:${CMAKE_SYSTEM_INCLUDE_PATH}>
    $<$<OR:$<C_COMPILER_ID:Intel>,$<BOOL:${MSVC_IDE}>>:$ENV{INCLUDE}>
    )

set (ASM_INCLUDE_DIRECTORIES
    ${IPP_CRYPTO_SOURCES_INCLUDE_DIR}
    ${IPP_CRYPTO_SOURCES_DIR}/asm_${ARCH}
    )

if(IPPCP_FIPS_MODE)
  file(GLOB IPPCP_FIPS_CERT_PUBLIC_HEADERS
      ${IPP_CRYPTO_INCLUDE_DIR}/ippcp/*.h
   )
  file(GLOB IPPCP_FIPS_CERT_INTERNAL_HEADERS
      ${IPPCP_FIPS_CERT_PUBLIC_HEADERS}
      ${IPP_CRYPTO_SOURCE_INCLUDE_DIR}/fips_cert_internal/*.h
   )
  file(GLOB IPPCP_FIPS_CERT_LIBRARY_C_SOURCES
      ${IPP_CRYPTO_SOURCES_DIR}/fips_cert/*.c
   )
  list(APPEND IPPCP_PUBLIC_HEADERS "${IPPCP_FIPS_CERT_PUBLIC_HEADERS}")
  list(APPEND LIBRARY_HEADERS "${IPPCP_FIPS_CERT_INTERNAL_HEADERS}")

  set_source_files_properties(${IPPCP_FIPS_CERT_LIBRARY_C_SOURCES} PROPERTIES INCLUDE_DIRECTORIES "${C_INCLUDE_DIRECTORIES}")

  # Add FIPS custom API header
  if(FIPS_CUSTOM_IPPCP_API_HEADER)
    message (STATUS "Using FIPS_CUSTOM_IPPCP_API_HEADER ......................... " ${FIPS_CUSTOM_IPPCP_API_HEADER})
    if(WIN32)
      set_source_files_properties(${IPPCP_FIPS_CERT_LIBRARY_C_SOURCES} PROPERTIES COMPILE_FLAGS "/FI${FIPS_CUSTOM_IPPCP_API_HEADER}")
    else()
      set_source_files_properties(${IPPCP_FIPS_CERT_LIBRARY_C_SOURCES} PROPERTIES COMPILE_FLAGS "-imacros ${FIPS_CUSTOM_IPPCP_API_HEADER}")
    endif()
  endif()
endif()

# Because of CMake bug (https://gitlab.kitware.com/cmake/cmake/issues/19178) it is impossible to add
# target specific NASM compiler options/definitions when using VS generator, but it is possible to specify
# them based on source files. So, here is the workaround - we spawn same assembler sources across different
# platform-specific directories and assign different definitions for each directory using set_source_files_properties().
#

=== sources/ippcp/crypto_mb/CMakeLists.txt ===
#=========================================================================
# Copyright (C) 2019 Intel Corporation
#
# Licensed under the Apache License,  Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# 	http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law  or agreed  to  in  writing,  software
# distributed under  the License  is  distributed  on  an  "AS IS"  BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the  specific  language  governing  permissions  and
# limitations under the License.
#=========================================================================

cmake_minimum_required(VERSION 3.18)

project("crypto_mb" C)

include("${CMAKE_CURRENT_SOURCE_DIR}/src/cmake/crypto_mb-utils.cmake")
mbx_getlibversion("${CMAKE_CURRENT_SOURCE_DIR}/include/crypto_mb/version.h")

if ((NOT DEFINED MBX_VER_MAJOR) OR
    (NOT DEFINED MBX_VER_MINOR) OR
    (NOT DEFINED MBX_VER_PATCH)   OR
    (NOT DEFINED MBX_INTERFACE_VERSION_MAJOR) OR
    (NOT DEFINED MBX_INTERFACE_VERSION_MINOR))
    message(WARNING "Cannot parse version from crypto_mb/version.h file. The project might be corrupted.")
endif()

set(CMAKE_CONFIGURATION_TYPES "Debug;Release" CACHE STRING "" FORCE)
if(NOT "${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
    message(STATUS "CMAKE_BUILD_TYPE is not set to Debug explicitly, defaulting to Release")
    set(CMAKE_BUILD_TYPE "Release")
endif()

if(NOT DEFINED MB_STANDALONE)
  set(MB_STANDALONE true)
endif()

set(CRYPTO_MB_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/include")
set(CRYPTO_MB_SOURCES_DIR "${CMAKE_CURRENT_SOURCE_DIR}/src")

set(MBX_DIR ${CMAKE_CURRENT_SOURCE_DIR})

set(CRYPTO_MB_DISPATCHER_DIR "${MBX_DIR}/dispatcher")

set(MB_DYN_LIB_TARGET    "crypto_mb")   # Dynamic library
set(MB_STATIC_LIB_TARGET "crypto_mb_s") # Static library

# Define public headers
file(GLOB MB_PUBLIC_HEADERS "${CRYPTO_MB_INCLUDE_DIR}/crypto_mb/*.h*")
# remove fips_cert.h header if fips-mode is not chosen
if(NOT DEFINED MBX_FIPS_MODE)
    list(REMOVE_ITEM MB_PUBLIC_HEADERS "${CRYPTO_MB_INCLUDE_DIR}/crypto_mb/fips_cert.h")
endif()

# Platform-specific definitions
set(l9_def "_L9" "SIMD_LEN=256")
set(k1_def "_K1" "USE_AMS_5x" "SIMD_LEN=512")

# Proper dispatching requires several optimization paths
set(MBX_PLATFORM_LIST k1 l9)

# check if L9 is supported by the compiler
set(MBX_CC_AVXIFMA_SUPPORT 0)

set(DEFAULT_AVXIFMA_GNU_COMPILER_VER 13.0.0)
set(DEFAULT_AVXIFMA_CLANG_COMPILER_VER 16.0.0)
set(DEFAULT_AVXIFMA_MSVC_COMPILER_VER 19.37)
if(WIN32)
  set(DEFAULT_AVXIFMA_ICX_COMPILER_VER 2025.0.0)
else()
  set(DEFAULT_AVXIFMA_ICX_COMPILER_VER 2024.2.0)
endif()

if((("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")       AND (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL DEFAULT_AVXIFMA_GNU_COMPILER_VER))   OR
   (("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")     AND (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL DEFAULT_AVXIFMA_CLANG_COMPILER_VER)) OR
   (("${CMAKE_C_COMPILER_ID}" STREQUAL "MSVC")      AND (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL DEFAULT_AVXIFMA_MSVC_COMPILER_VER))  OR
   (("${CMAKE_C_COMPILER_ID}" STREQUAL "IntelLLVM") AND (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL DEFAULT_AVXIFMA_ICX_COMPILER_VER)))
    set(MBX_CC_AVXIFMA_SUPPORT 1)
endif()

if(MBX_CC_AVXIFMA_SUPPORT)
  message(STATUS "Intel® AVX-IFMA .............................. on")
else()
  if(WIN32)
    message(STATUS "Intel® AVX-IFMA .............................. off, compiler version GCC >= 13.0.0, CLANG >= 16.0.0, Intel ICX >= 2025.0.0 or MSVC >= 17.7 is required")
  else()
    message(STATUS "Intel® AVX-IFMA .............................. off, compiler version GCC >= 13.0.0, CLANG >= 16.0.0, Intel ICX >= 2024.2.0 or MSVC >= 17.7 is required")
  endif()
endif()

if(MB_STANDALONE)
    foreach( OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES} )
        string( TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG )
        set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} "${CMAKE_BINARY_DIR}/bin")
        set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} "${CMAKE_BINARY_DIR}/bin")
        set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} "${CMAKE_BINARY_DIR}/bin")
    endforeach( OUTPUTCONFIG CMAKE_CONFIGURATION_TYPES )
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
    set(INTERNAL_INCLUDE_DIR "${CMAKE_BINARY_DIR}/include/autogen_1cpu")
else()
    # Make variables below accessible in parent CMakeLists.txt
    set(MBX_INTERFACE_VERSION ${MBX_INTERFACE_VERSION} PARENT_SCOPE)
    set(MB_PUBLIC_HEADERS ${MB_PUBLIC_HEADERS} PARENT_SCOPE)
    set(MB_DYN_LIB_TARGET    "${MB_DYN_LIB_TARGET}" PARENT_SCOPE)
    set(MB_STATIC_LIB_TARGET "${MB_STATIC_LIB_TARGET}" PARENT_SCOPE)
endif()

if(MB_STANDALONE)
    find_package(Python REQUIRED)
    if(Python_Interpreter_FOUND)
        message (STATUS "PYTHON_VERSION_STRING ................. " ${Python_VERSION})
        else()
        message (STATUS "PYTHON_VERSION_STRING ................. Python not found" )
    endif()
    if(NOT CMAKE_OUTPUT_DIR)
        set(CMAKE_OUTPUT_DIR              "${CMAKE_BINARY_DIR}/.build")
    endif()
endif()

if(BORINGSSL OR BABASSL OR TONGSUO) # off by default
    # BoringSSL doesn't appear to have version information found
    # Tongsuo has own versioning
    # by find_package(OpenSSL)
    find_package(OpenSSL REQUIRED)
else()
    find_package(OpenSSL 3.0.8 REQUIRED) # set -DOPENSSL_INCLUDE_DIR= -DOPENSSL_LIBRARIES= -DOPENSSL_ROOT_DIR= to use patched
endif()

if(BABASSL) # off by default
    message(WARNING "-DBABASSL:BOOL=on flag is deprecated and targeted to be removed in the future releases. Please use -DTONGSUO:BOOL=on instead.")
endif()

if(BN_OPENSSL_PATCH)
    # Link static OpenSSL only for patched version
    set(OPENSSL_USE_STATIC_LIBS TRUE)
endif()

include_directories(
    ${CRYPTO_MB_INCLUDE_DIR}
    ${OPENSSL_INCLUDE_DIR}
    ${INTERNAL_INCLUDE_DIR}
    ${INTERNAL_INCLUDE_DIR}/single_cpu/crypto_mb
    $<$<C_COMPILER_ID:Intel>:$ENV{ROOT}/compiler/include $ENV{ROOT}/compiler/include/icc>
    $<$<NOT:$<C_COMPILER_ID:Intel>>:${CMAKE_SYSTEM_INCLUDE_PATH}>
    $<$<OR:$<C_COMPILER_ID:Intel>,$<BOOL:${MSVC_IDE}>>:$ENV{INCLUDE}>
)

add_subdirectory(src)

=== sources/ippcp/crypto_mb/src/CMakeLists.txt ===
#=========================================================================
# Copyright (C) 2019 Intel Corporation
#
# Licensed under the Apache License,  Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# 	http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law  or agreed  to  in  writing,  software
# distributed under  the License  is  distributed  on  an  "AS IS"  BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the  specific  language  governing  permissions  and
# limitations under the License.
#=========================================================================

# Define defaults for every supported compiler
set(DEFAULT_GNU_COMPILER_VER 8.2.0)
set(DEFAULT_CLANG_COMPILER_VER 9.0.0)
set(DEFAULT_Intel_COMPILER_VER 19.0.0)

# Check min compiler version
if(("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU") AND (CMAKE_C_COMPILER_VERSION VERSION_LESS DEFAULT_GNU_COMPILER_VER))
    message(FATAL_ERROR "GNU C Compiler version must be 8.2 or higher")
endif()
if(("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang") AND (CMAKE_C_COMPILER_VERSION VERSION_LESS DEFAULT_CLANG_COMPILER_VER))
  message(FATAL_ERROR "Clang C Compiler version must be 9.0 or higher")
endif()
if(("${CMAKE_C_COMPILER_ID}" STREQUAL "Intel") AND (CMAKE_C_COMPILER_VERSION VERSION_LESS DEFAULT_Intel_COMPILER_VER))
    message(FATAL_ERROR "Compiler version must be 19.0 or higher")
endif()

include("${CRYPTO_MB_SOURCES_DIR}/cmake/common.cmake")
include(${COMPILER_OPTIONS_FILE}) # Get ${CMAKE_C_FLAGS}, ${CMAKE_CXX_FLAGS} and ${AVX512_CFLAGS}

# Sources
file(GLOB RSA_SOURCES           "${CRYPTO_MB_SOURCES_DIR}/rsa/*.c"
                                "${CRYPTO_MB_SOURCES_DIR}/rsa/internal_avx2/*.c"
                                "${CRYPTO_MB_SOURCES_DIR}/rsa/internal_avx512/*.c")
file(GLOB COMMON_SOURCES        "${CRYPTO_MB_SOURCES_DIR}/common/*.c")

file(GLOB X25519_SOURCES        "${CRYPTO_MB_SOURCES_DIR}/x25519/*.c"
                                "${CRYPTO_MB_SOURCES_DIR}/x25519/internal_avx512/*.c")

file(GLOB ECNIST_SOURCES        "${CRYPTO_MB_SOURCES_DIR}/ecnist/*.c"
                                "${CRYPTO_MB_SOURCES_DIR}/ecnist/internal_avx512/*.c")

file(GLOB SM2_SOURCES           "${CRYPTO_MB_SOURCES_DIR}/sm2/*.c"
                                "${CRYPTO_MB_SOURCES_DIR}/sm2/internal_avx512/*.c")

file(GLOB SM3_SOURCES           "${CRYPTO_MB_SOURCES_DIR}/sm3/*.c"
                                "${CRYPTO_MB_SOURCES_DIR}/sm3/internal_avx512/*.c")

# SM4 Sources
file(GLOB SM4_SOURCES           "${CRYPTO_MB_SOURCES_DIR}/sm4/*.c"
                                "${CRYPTO_MB_SOURCES_DIR}/sm4/internal_avx512/*.c"
                                "${CRYPTO_MB_SOURCES_DIR}/sm4/gcm/*.c"
                                "${CRYPTO_MB_SOURCES_DIR}/sm4/gcm/internal_avx512/*.c"
                                "${CRYPTO_MB_SOURCES_DIR}/sm4/ccm/*.c"
                                "${CRYPTO_MB_SOURCES_DIR}/sm4/ccm/internal_avx512/*.c")

file(GLOB ED25519_SOURCES       "${CRYPTO_MB_SOURCES_DIR}/ed25519/*.c"
                                "${CRYPTO_MB_SOURCES_DIR}/ed25519/internal_avx512/*.c")

file(GLOB EXP_SOURCES           "${CRYPTO_MB_SOURCES_DIR}/exp/*.c")

file(GLOB FIPS_CERT_SOURCES     "${CRYPTO_MB_SOURCES_DIR}/fips_cert/*.c")

# Headers
file(GLOB MB_PRIVATE_HEADERS   "${CRYPTO_MB_INCLUDE_DIR}/internal/common/*.h"
                               "${CRYPTO_MB_INCLUDE_DIR}/internal/ecnist/*.h"
                               "${CRYPTO_MB_INCLUDE_DIR}/internal/rsa/*.h"
                               "${CRYPTO_MB_INCLUDE_DIR}/internal/sm2/*.h"
                               "${CRYPTO_MB_INCLUDE_DIR}/internal/sm3/*.h"
                               "${CRYPTO_MB_INCLUDE_DIR}/internal/sm4/*.h"
                               "${CRYPTO_MB_INCLUDE_DIR}/internal/ed25519/*.h"
                               "${CRYPTO_MB_INCLUDE_DIR}/internal/exp/*.h"
                               "${CRYPTO_MB_INCLUDE_DIR}/internal/fips_cert/*.h")
file(GLOB OPENSSL_HEADERS      "${OPENSSL_INCLUDE_DIR}/openssl/*.h")

set(CRYPTO_MB_SOURCES_ORIGINAL ${RSA_SOURCES} ${COMMON_SOURCES} ${X25519_SOURCES} ${ECNIST_SOURCES} ${SM2_SOURCES} ${SM3_SOURCES} ${SM4_SOURCES} ${ED25519_SOURCES} ${EXP_SOURCES})
set(CRYPTO_MB_HEADERS ${MB_PUBLIC_HEADERS} ${MB_PRIVATE_HEADERS} ${OPENSSL_HEADERS})

set(WIN_RESOURCE_FILE ${CRYPTO_MB_SOURCES_DIR}/common/crypto_mb_ver.rc)
set(CPU_FEATURES_FILE ${CRYPTO_MB_SOURCES_DIR}/common/cpu_features.c)
set(MBX_VERSION_FILE ${CRYPTO_MB_SOURCES_DIR}/common/ifma_version.c)

# Disable compiler optimizations for this file, as compiler adds some ISA specific code
# which is unwanted for functions that are aimed to work on any CPU
list(REMOVE_ITEM CRYPTO_MB_SOURCES_ORIGINAL ${CPU_FEATURES_FILE})
if("${OS_STRING}" STREQUAL "windows")
    set_source_files_properties(${CPU_FEATURES_FILE} PROPERTIES  COMPILE_FLAGS  "${CMAKE_C_FLAGS_SECURITY} /Od")
else()
    set_source_files_properties(${CPU_FEATURES_FILE} PROPERTIES  COMPILE_FLAGS  "${CMAKE_C_FLAGS_SECURITY} -O0")
endif()

if(BN_OPENSSL_PATCH) # Off by default
    list(APPEND AVX512_LIBRARY_DEFINES "BN_OPENSSL_PATCH")
endif()

set(CRYPTO_MB_API ${MB_PUBLIC_HEADERS})
list(REMOVE_ITEM CRYPTO_MB_API ${CRYPTO_MB_INCLUDE_DIR}/crypto_mb/cpu_features.h 
                               ${CRYPTO_MB_INCLUDE_DIR}/crypto_mb/defs.h 
                               ${CRYPTO_MB_INCLUDE_DIR}/crypto_mb/status.h)

# Generate single-CPU headers
set(MBX_ONE_CPU_FOLDER ${INTERNAL_INCLUDE_DIR}/single_cpu/crypto_mb)
set(MBX_ONE_CPU_GENERATOR   ${MBX_DIR}/gen_cpu_spc_header/gen_cpu_spc_1cpu_header_crypto_mb.py)
set(MBX_INTERNAL_GENERATOR  ${MBX_DIR}/gen_cpu_spc_header/gen_cpu_spc_header_crypto_mb.py)
foreach( header ${CRYPTO_MB_API})
    execute_process(COMMAND ${Python_EXECUTABLE} ${MBX_ONE_CPU_GENERATOR} ${header} ${MBX_ONE_CPU_FOLDER})
    execute_process(COMMAND ${Python_EXECUTABLE} ${MBX_INTERNAL_GENERATOR} ${header} ${INTERNAL_INCLUDE_DIR})
endforeach()

file(GLOB MBX_ONE_CPU_HEADERS "${MBX_ONE_CPU_FOLDER}/*.h")
file(GLOB MBX_CPU_SPC_HEADERS "${INTERNAL_INCLUDE_DIR}/*.h")

# Copy headers to the output directory
foreach( OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES})
   string( TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG )
   file(COPY ${MBX_ONE_CPU_FOLDER}
        DESTINATION "${CMAKE_OUTPUT_DIR}/${OUTPUTCONFIG}/include/single_cpu")
endforeach( OUTPUTCONFIG CMAKE_CONFIGURATION_TYPES )

if(MBX_CC_AVXIFMA_SUPPORT)
   set(MBX_AVXIFMA_SUPPORT_DEFINE "_MBX_AVX_IFMA_SUPPORTED")
endif()

foreach(opt ${MBX_PLATFORM_LIST})
    # Populate C source files in to corresponding folders per library 'letter'
    set(mbx_c_cache_dir "${CMAKE_BINARY_DIR}/c_sources/crypto_mb/${opt}/c_${ARCH}")
    file(MAKE_DIRECTORY ${mbx_c_cache_dir})
    # Add a prefix to the source files, so that corresponding object files in the merged library are unique named
    foreach (file ${CRYPTO_MB_SOURCES_ORIGINAL})
        get_filename_component(basename ${file} NAME)
        configure_file(${file} ${mbx_c_cache_dir}/${opt}_${basename} COPYONLY)
    endforeach()
    file (GLOB MBX_C_SOURCES_${opt}
        ${mbx_c_cache_dir}/*.c
    )
    set(OPT_FLAGS_${opt} ${${opt}_opt})

    # Put a specific define into the library if Intel® AVX-IFMA instructions are supported by the compiler
    set(MBX_LIBRARY_DEFINES "${MBX_AVXIFMA_SUPPORT_DEFINE}" "${${opt}_def}")

    set_source_files_properties(${MBX_C_SOURCES_${opt}} PROPERTIES COMPILE_DEFINITIONS  "${MBX_LIBRARY_DEFINES}"
                                                                   COMPILE_FLAGS        "${OPT_FLAGS_${opt}} ${CMAKE_C_FLAGS_SECURITY}")
endforeach()

# build object libraries
set(MBX_TARGET_NAME ${MB_STATIC_LIB_TARGET})

foreach(opt ${MBX_PLATFORM_LIST})
    set(MBX_ST_ITER ${MBX_TARGET_NAME}_${opt})
    add_library(${MBX_ST_ITER} OBJECT ${CRYPTO_MB_HEADERS} ${MBX_C_SOURCES_${opt}})
    set(MBX_MERGED_DEPENDENCY ${MBX_MERGED_DEPENDENCY} $<TARGET_OBJECTS:${MBX_ST_ITER}>)
    list(APPEND MBX_LIB_STATIC ${MBX_ST_ITER})
endforeach()

set(DISPATCHER ${CMAKE_BINARY_DIR}/dispatcher/crypto_mb)
file(MAKE_DIRECTORY ${DISPATCHER})
set(DISPATCHER_GENERATOR ${CRYPTO_MB_DISPATCHER_DIR}/gen_disp_crypto_mb.py)
foreach(incl ${CRYPTO_MB_API})
    execute_process(COMMAND ${Python_EXECUTABLE} ${DISPATCHER_GENERATOR} -i ${incl} -o ${DISPATCHER} -l "${MBX_PLATFORM_LIST}" -c ${CMAKE_C_COMPILER_ID}
        RESULT_VARIABLE result
        )
endforeach()

file(GLOB DISPATCHER_HEADERS
${CMAKE_BINARY_DIR}/dispatcher/crypto_mb/*.h
)

file(GLOB DISPATCHER_C_SOURCES
${CMAKE_BINARY_DIR}/dispatcher/crypto_mb/*.c
)

if(MBX_FIPS_MODE)
    set_source_files_properties(${FIPS_CERT_SOURCES} PROPERTIES COMPILE_DEFINITIONS "MBX_FIPS_MODE")
    set(DISPATCHER_C_SOURCES ${DISPATCHER_C_SOURCES} ${FIPS_CERT_SOURCES})
endif()

set(MB_LIB_TARGET ${MB_DYN_LIB_TARGET})

set_source_files_properties(${DISPATCHER_C_SOURCES} PROPERTIES COMPILE_FLAGS "${CMAKE_C_FLAGS_SECURITY}")

# Static library
if(WIN32)
    add_library(${MB_STATIC_LIB_TARGET} STATIC ${DISPATCHER_HEADERS} ${DISPATCHER_C_SOURCES} ${MBX_MERGED_DEPENDENCY} ${CPU_FEATURES_FILE} ${WIN_RESOURCE_FILE})
else()
    add_library(${MB_STATIC_LIB_TARGET} STATIC ${DISPATCHER_HEADERS} ${DISPATCHER_C_SOURCES} ${MBX_MERGED_DEPENDENCY} ${CPU_FEATURES_FILE})
endif()

set_target_properties(${MB_STATIC_LIB_TARGET} PROPERTIES C_VISIBILITY_PRESET hidden
                                                        VISIBILITY_INLINES_HIDDEN ON
                                                        PUBLIC_HEADER "${MB_PUBLIC_HEADERS}"
                                                        PRIVATE_HEADER "${MBX_ONE_CPU_HEADERS}")

if(WIN32)
    set_target_properties(${MB_STATIC_LIB_TARGET} PROPERTIES OUTPUT_NAME "${MB_LIB_TARGET}mt")
else()
    set_target_properties(${MB_STATIC_LIB_TARGET} PROPERTIES OUTPUT_NAME "${MB_LIB_TARGET}")
endif()

target_link_libraries(${MB_STATIC_LIB_TARGET} OpenSSL::Crypto)

# Static lib installation
if(MB_STANDALONE)
    install(TARGETS ${MB_STATIC_LIB_TARGET}
            ARCHIVE DESTINATION "lib"
            PUBLIC_HEADER DESTINATION "include/crypto_mb"
            PRIVATE_HEADER DESTINATION "tools/staticlib/crypto_mb")
else()
    install(TARGETS ${MB_STATIC_LIB_TARGET}
            ARCHIVE DESTINATION "lib/intel64"
            PUBLIC_HEADER DESTINATION "include/crypto_mb"
            PRIVATE_HEADER DESTINATION "tools/intel64/staticlib/crypto_mb")
endif()


# Create shared library
if(DYNAMIC_LIB OR MB_STANDALONE)

    add_library(${MB_DYN_LIB_TARGET} SHARED common/emptyfile.c common/crypto_mb_ver.rc) # emptyfile.c to suppress the cmake warning

    set_target_properties(${MB_DYN_LIB_TARGET} PROPERTIES C_VISIBILITY_PRESET hidden
                                                          VISIBILITY_INLINES_HIDDEN ON
                                                          LINK_FLAGS "${LINK_FLAGS_DYNAMIC} ${LINK_FLAG_SECURITY}"
                                                          PUBLIC_HEADER "${MB_PUBLIC_HEADERS}"
                                                          PRIVATE_HEADER "${MBX_ONE_CPU_HEADERS}"
                                                          )

    if(UNIX)
        set_target_properties(${MB_DYN_LIB_TARGET} PROPERTIES  VERSION   ${MBX_INTERFACE_VERSION}
                                                               SOVERSION ${MBX_INTERFACE_VERSION_MAJOR})
    endif()

    target_link_libraries(${MB_DYN_LIB_TARGET} ${MB_STATIC_LIB_TARGET}) # link to the static merged

endif(DYNAMIC_LIB OR MB_STANDALONE)

# Installation of the shared library
if (MB_STANDALONE) # standalone crypto_mb's cmake run
    install(TARGETS ${MB_DYN_LIB_TARGET}
            LIBRARY DESTINATION "lib"
            RUNTIME DESTINATION "lib"
            PUBLIC_HEADER DESTINATION "include/crypto_mb"
            PRIVATE_HEADER DESTINATION "tools/staticlib/crypto_mb")
elseif (DYNAMIC_LIB) # build from ippcp's cmake

=== debian/changelog ===
ipp-crypto (1:1.0.0-0ubuntu1) plucky; urgency=medium

  * d/changelog : add epoch to version since upstream uses now
      semantic versioning
  * d/control : update package names for ipcrypto-mb and libippcp
  * d/control : change upstream vcs and description
  * d/p : refresh patch
  * New upstream version 1.0.0 (LP: #2089569)
  * d/watch : upstream repo renaming and versioning scheme change

 -- Hector Cao <hector.cao@canonical.com>  Mon, 25 Nov 2024 12:45:16 +0100

ipp-crypto (2021.12.1-0ubuntu1) oracular; urgency=medium

  * New upstream release (LP: #2075496).

 -- Hector Cao <hector.cao@canonical.com>  Wed, 31 Jul 2024 13:57:03 +0200

ipp-crypto (2021.10.0-0ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:31:45 +0000

ipp-crypto (2021.10.0-0ubuntu2) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 18:16:06 +0000

ipp-crypto (2021.10.0-0ubuntu1) noble; urgency=medium

  * Initial release. (LP: #2048917)

 -- Hector Cao <ubuntu-devel-discuss@lists.ubuntu.com>  Wed, 22 Feb 2024 09:20:34 +0100

=== debian/control ===
Source: ipp-crypto
Rules-Requires-Root: no
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Hector Cao <hector.cao@canonical.com>
Build-Depends: debhelper-compat (=13),
               cmake,
               dh-cmake,
               dh-exec,
               clang (>= 16),
               nasm,
               libssl-dev
Standards-Version: 4.6.2
Homepage: https://github.com/intel/cryptography-primitives

Package: libippcp12
Section: libs
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Intel® Cryptography Primitives Library
 Intel® Cryptography Primitives Library (Intel® IPP) Cryptography is a
 secure, fast and lightweight library of building blocks for cryptography,
 highly-optimized for various Intel® CPUs.
 .
 Key features:
  * sym crypto primitives
  * one-way hash primitives
  * data authentication primitives
  * pub key crypto functions
  * multi-buffer RSA, ECDSA, SM3, x25519
  * finite field arithmetic functions
  * big number integer arithmetic funtions
  * PRNG/TRNG and Prime numbers generation

Package: libippcp-dev
Section: libdevel
Architecture: amd64
Depends: ${misc:Depends}, libippcp12 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: Intel® Cryptography Primitives Library development files
 Intel® Cryptography Primitives Library (Intel® IPP) Cryptography is a
 secure, fast and lightweight library of building blocks for cryptography,
 highly-optimized for various Intel® CPUs.
 This package contains the development libraries and headers.

Package: libcrypto-mb12
Section: libs
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Intel® Cryptography Primitives Library Multi-buffer
 Some of the cryptography algorithms cannot be parallelized due to
 their specificity (eg the RSA algorithm).
 The way to get high-performance implementations of such cryptographic
 algorithms is a parallel processing using *single instruction,
 multiple data* (SIMD) architecture. The usage model implies
 presence of several independent and homogeneous (encryption or decryption)
 requests for RSA operations, using of SIMD leads to performance
 improvement.
 .
 Multi-buffer processing collects up to eight RSA operations.
 Each request is computed independently from the others, so it
 is possible to process several packets at the same time.
 .
 This library consists of highly-optimized kernels taking advantage
 of Intel’s multi-buffer processing and Intel® AVX-512 instruction set.

Package: libcrypto-mb-dev
Section: libdevel
Architecture: amd64
Depends: ${misc:Depends}, libcrypto-mb12 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: Intel® IPP Cryptography Multi-buffer development files
 This package contains the development libraries and headers.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)v(\d[\d.][\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
             https://github.com/intel/cryptography-primitives/tags \
             (?:.*?/)?v(\d[\d.][\d.]*)\.tar\.gz debian uupdate
